#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityVIPCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityVIPCFG> M_ActivityVIPCFG::msSingleton(nullptr);

int M_ActivityVIPCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityVIPCFGData* M_ActivityVIPCFG::GetData(int VipLv)
{
	auto it = mMapData.find(VipLv);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityVIPCFGData>& M_ActivityVIPCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityVIPCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityVIPCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityVIPCFGData data;
		data.mVipLv = element->IntAttribute("VipLv");
		{
			const char* ActiviyScratchTicket = element->Attribute("ActiviyScratchTicket");
			std::vector<std::string> vecActiviyScratchTicket;
			boost::split(vecActiviyScratchTicket, ActiviyScratchTicket, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecActiviyScratchTicket.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecActiviyScratchTicket[i].c_str(), &temp))
				{
					data.mActiviyScratchTicket.push_back(temp);
				}
			}
		}
		{
			const char* ActiviyAdventure = element->Attribute("ActiviyAdventure");
			std::vector<std::string> vecActiviyAdventure;
			boost::split(vecActiviyAdventure, ActiviyAdventure, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecActiviyAdventure.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecActiviyAdventure[i].c_str(), &temp))
				{
					data.mActiviyAdventure.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mVipLv) != mMapData.end())std::cout <<"data refind:" << data.mVipLv << std::endl;
		assert(mMapData.find(data.mVipLv) == mMapData.end());
		mMapData.insert(std::make_pair(data.mVipLv, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityVIPCFG::Load()
{
	Load("../Config/M_ActivityVIPCFG.xml");
}

M_ActivityVIPCFG* M_ActivityVIPCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityVIPCFG());
	}
	return msSingleton.get();
}
